% calcul des limites en symbolique.
syms t;
xp=log((t^2-1)/4);
xm=log((-t^2+1)/4);
yp=sqrt(3)*log((t+1)/(t-1));
ym=sqrt(3)*log((t+1)/(-t+1));
X1=limit(yp/xp,t,1,'right');
X2=limit(ym/xm,t,1,'left');
X3=limit(yp+sqrt(3)*xp,t,1,'right');
X4=limit(ym+sqrt(3)*xm,t,1,'left');
disp('limite de y(t)/x(t) quand t tend vers 1+');
pretty(X1);
disp('limite de y(t)/x(t) quand t tend vers 1-');
pretty(X2);
disp('limite de y(t)+sqrt(3)*x(t) quand t tend vers 1-');
pretty(X3);
disp('limite de y(t)+sqrt(3)*x(t) quand t tend vers 1+');
pretty(X4);
disp('Appuyez sur une touche pour continuer');
pause;

% trac de la courbe, par morceaux.
clf;
x=inline('log(abs((t.^2-1)/4))');
y=inline('sqrt(3)*log(abs((t+1)./(t-1)))');
t1=0:0.001:1-1e-4;
t2=1+1e-4:0.001:50;
hold on;
plot(x(t1),y(t1),'b',x(t2),y(t2),'b',x(t1),-y(t1),'b',x(t2),-y(t2),'b');
h=gca;
xlimm=get(h,'XLim');
plot(xlimm,sqrt(3)*xlimm,'r');
plot(xlimm,-sqrt(3)*xlimm,'r');
hold off;