% script de l'exercice 5

% fonction de trac de la spirale dfinie en polaire r(theta)=a*e^(m*theta)
% et de sa dveloppe avec trois variantes : 
% 1) : dveloppe de la spirale dfinie par 
%        x(theta)=cos(theta+pi/2)*m*a*e^(m*theta);
%        y(theta)=sin(theta+pi/2)*m*a*e^(m*theta);
% 2) : dveloppe de la spirale obtenue comme image de la spirale 
%      par une similitude de centre 0, de rapport m et d'angle pi/2.
% 3) : utilisation des formules gnrale et des fonctions 
%      programme en symbolique 
%
%
%
%
% ************ Fonctions auxiliaires utilises ************
%
%    prepar_developee_pol.m et trace_developee_pol 
%
% *********************************************************
%
% (c) 2006 by      Jrme BASTIEN,
%                  UTBM, Dpartement GMC, Belfort
%                  E-Mail : jerome.bastien@utbm.fr

a=input('Entrez a : ');
m=input('Entrez m : ');
% intervalle d'tude
thetamin=-pi/2;
thetamax=3*pi/2;
h=0.01;
thetacar=-pi/2:pi/2:3*pi/2;
% calculs gnraux.
thetafcn=inline([num2str(a,16),'*exp(theta*',num2str(m,16),')']);
theta=thetamin:h:thetamax;
rho=feval(thetafcn,theta);
co=cos(theta);
si=sin(theta);
X=rho.*co;
Y=rho.*si;
% calculs pour la variante 1
ap=a*m;
mp=m;
thetafcnbis=inline([num2str(ap,16),'*exp(theta*',num2str(mp,16),')']);
rhobis=feval(thetafcnbis,theta);
cobis=cos(theta+pi/2);
sibis=sin(theta+pi/2);
Xbis1=rhobis.*cobis;
Ybis1=rhobis.*sibis;
rhocar=feval(thetafcn,thetacar);
rhocarbis=feval(thetafcnbis,thetacar);
cocar=cos(thetacar+pi/2);
sicar=sin(thetacar+pi/2);
coacar=cos(thetacar);
siacar=sin(thetacar);
xacar1=rhocar.*coacar;
yacar1=rhocar.*siacar;
xcar1=rhocarbis.*cocar;
ycar1=rhocarbis.*sicar;
% calculs pour la variante 2
Xbis2=-m*Y;
Ybis2=m*X;
% calculs pour la variante 3
thetach=[num2str(a,16),'*exp(theta*',num2str(m,16),')'];
[testnonnul,Ix,Iy]=prepar_developee_pol(1,thetach);


% trac
% trac pour la variante 1 
clf;
hold on;
axis equal;
plot(X,Y,Xbis1,Ybis1);
legend('courbe','dveloppe',0);
hb=gca;
xlimm=get(hb,'XLim');
ylimm=get(hb,'YLim');
plot(xlimm,[0 0],'k');
plot([0 0],ylimm,'k');
plot(xacar1,yacar1,'o',xcar1,ycar1,'o');
for t=1:length(thetacar)
    plot([xacar1(t) xcar1(t)],[yacar1(t) ycar1(t)],'r');
end
hold off;
disp(' ');
disp('Appuyez sur une touche pour continuer');
pause; 

% trac pour la variante 2
clf;
hold on;
axis equal;
plot(X,Y,Xbis2,Ybis2);
legend('courbe','dveloppe',0);
hb=gca;
xlimm=get(hb,'XLim');
ylimm=get(hb,'YLim');
plot(xlimm,[0 0],'k');
plot([0 0],ylimm,'k');
hold off;
disp(' ');
disp('Appuyez sur une touche pour continuer');
pause; 

% deux tracs pour la variante 3 
clf;
thetamin=-pi/2;
thetamax=pi/2;
trace_developee_pol(thetamin,thetamax,fix((thetamax-thetamin)/h),linspace(thetamin,thetamax,3),testnonnul,Ix,Iy,thetach);
disp(' ');
disp('Appuyez sur une touche pour continuer');
pause; 
trace_developee_pol(thetamin,thetamax,fix((thetamax-thetamin)/h),linspace(thetamin,thetamax,40),testnonnul,Ix,Iy,thetach);




