% script TDcpmme_exo6.m : trac de l'astrode (pour a=1) et de sa dveloppe.

% 0) trac du rseau de segments de droite.
% Ensuite, trac de la courbe dfinie en paramtrique par 
% X(t)=cos^3(t),
% Y(t)=sin^3(t),
% pour t dans [0,2pi],
% et de sa dveloppe avec trois variantes :  
% 1) : dveloppe de l'astrode dfinie en paramtrique par  
%        Xd(t)=cos(t)*(2-cos(2t)),
%        Yd(t)=sin(t)*(2+cos(2t)),
% 2) : dveloppe de l'astrode  obtenue comme image de l'astrode  
%      par une similitude de centre 0, de rapport 2 et d'angle pi/4.
% 3) : utilisation des formules gnrale et des fonctions 
%      programmes en symbolique
%
%
%
% ************ Fonctions auxiliaires utilises ************
%
%    prepar_develop_param01 et trace_develop_param01
%
% *********************************************************
%
% (c) 2005 by      Jrme BASTIEN,
%                  UTBM, Dpartement GMC, Belfort
%                  E-Mail : jerome.bastien@utbm.fr

% calcul
clear all;
% caluls pour le trac du rseau de segments de droite.
h0=0.05;
t0=0:h0:pi/2;
x0=cos(t0);
y0=sin(t0);
N0=length(t0);
% calculs gnraux.
tmin=0;
tmax=2*pi;
h=0.005;
t=tmin:h:tmax;
tcar=[pi/8:pi/8:pi/2];
% caluls pour le trac de l'astrode
C=cos(t);
S=sin(t);
C2=cos(2*t);
X=C.^3;
Y=S.^3;
Ccar=cos(tcar);
Scar=sin(tcar);
C2car=cos(2*tcar);
xacar1=Ccar.^3;
yacar1=Scar.^3;
% caluls pour le trac de la dveloppe de l'astrode, variante 1:
Xbis1=C.*(2-C2);
Ybis1=S.*(2+C2);
xcar1=Ccar.*(2-C2car);
ycar1=Scar.*(2+C2car);
% caluls pour le trac de la dveloppe de l'astrode, variante 2:
Xbis2=sqrt(2)*(X-Y);
Ybis2=sqrt(2)*(X+Y);
% caluls pour le trac de la dveloppe de l'astrode, variante 3:
[testnonnul,Ix,Iy]=prepar_developee(1,'(cos(t))^3','(sin(t))^3') 




% Trac
% trac du rseau de segments.
clf;
hold on;
axis equal;
plot([0 0],[0 1]);
for i=1:N0
   plot([x0(i),0],[0,y0(i)]);
end
hold off;
disp(' ');
disp('Appuyez sur une touche pour continuer');
pause;
% Trac de l'astrode et de sa dveloppe, variante 1:
clf;
hold on;
axis equal;
plot(X,Y,Xbis1,Ybis1);
legend('Courbe','Dveloppe',0);
hb=gca;
xlimm=get(hb,'XLim');
ylimm=get(hb,'YLim');
plot(xlimm,[0 0],'k:');
plot([0 0],ylimm,'k:');
plot(ylimm,ylimm,'k:');
plot(xacar1,yacar1,'o',xcar1,ycar1,'o');
for J=1:length(xacar1)
    plot([xacar1(J) xcar1(J)],[yacar1(J) ycar1(J)],'r');
end
hold off;
disp(' ');
disp('Appuyez sur une touche pour continuer');
pause;
% Trac de l'astrode et de sa dveloppe, variante 2:
clf;
hold on;
axis equal;
plot(X,Y,Xbis2,Ybis2);
legend('Courbe','Dveloppe',0);
hb=gca;
xlimm=get(hb,'XLim');
ylimm=get(hb,'YLim');
plot(xlimm,[0 0],'k:');
plot([0 0],ylimm,'k:');
plot(ylimm,ylimm,'k:');
hold off;
disp(' ');
disp('Appuyez sur une touche pour continuer');
pause;
% Trac de l'astrode et de sa dveloppe, variante 3:
clf;
trace_developee(tmin,tmax,fix((tmax-tmin)/h),tcar,testnonnul,Ix,Iy,'(cos(t))^3','(sin(t))^3');
hold on;
hb=gca;
xlimm=get(hb,'XLim');
ylimm=get(hb,'YLim');
plot(xlimm,[0 0],'k:');
plot([0 0],ylimm,'k:');
plot(ylimm,ylimm,'k:');
hold off;
disp(' ');
disp('Appuyez sur une touche pour continuer');
pause;
clf;
trace_developee(0,pi/2,500,linspace(0,pi/2,20),testnonnul,Ix,Iy,'(cos(t))^3','(sin(t))^3');
hold on;
hb=gca;
xlimm=get(hb,'XLim');
ylimm=get(hb,'YLim');
plot(xlimm,[0 0],'k:');
plot([0 0],ylimm,'k:');
plot(ylimm,ylimm,'k:');
hold off;

